#include <cstdio>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <ctime>
using namespace std;

const int MAX_N = 32;
const double eps = 1e-7;
const double INF = 1e100;

struct point { double x, y; };

int n;
point A[MAX_N];

int V[MAX_N];  // color
int B[MAX_N];  // best colorization

double best_sum = INF;

void input ()
{
	int i;

	scanf ("%d", &n);

	for (i=1; i<=n; i++)
		scanf ("%lf%lf", &A[i].x, &A[i].y);

	random_shuffle (A+1,A+n+1);
}

double surface (point &a, point &b, point &c)
{
	return fabs((b.x-a.x)*(c.y-b.y) - (c.x-b.x)*(b.y-a.y)) / 2.0;
}

/*
void greedy ()
{
	int q, i, j, k;
	int bi, bj, bk;
	double S, bs;

	best_sum = 0.0;
	for (q=1; q<=n/3; q++) {
		bs=INF;
		for (i=1; i<=n; i++) if (!B[i])
			for (j=i+1; j<=n; j++) if (!B[j])
				for (k=j+1; k<=n; k++) if (!B[k])
					if ((S=surface(A[i],A[j],A[k])) > eps)
						if (S<bs)
							bs=S, bi=i, bj=j, bk=k;

		best_sum += bs;
		B[bi]=B[bj]=B[bk]=q;
	}
}
*/

void brute (int num=1, double sum=0.0)
{
	// optimization
	if (sum > best_sum)
		return;

	// terminal
	if (num>n/3) {
		if (sum<best_sum) {
			best_sum = sum;
			memcpy(B,V,sizeof(V));
		}
		return;
	}

	int i, j, k;
	static double S;

	for (i=1; V[i]; i++) ;

	for (j=i+1; j<=n; j++) if (!V[j])
		for (k=j+1; k<=n; k++) if (!V[k]) 
			if ((S=surface(A[i],A[j],A[k])) > eps) {
				V[i]=V[j]=V[k]=num;
				brute (num+1,sum+S);
				V[i]=V[j]=V[k]=0;
			}
}

void output ()
{
	int i, j;

	printf ("%lf\n", best_sum);

	for (i=1; i<=n/3; i++) {
		for (j=1; j<=n; j++)
			if (B[j]==i)
				printf ("%d ", j);
		printf ("\n");
	}
}

int main ()
{
	input ();
	//greedy ();
	brute ();
	output ();

	//printf ("time: %.2lf\n", (double)clock()/CLOCKS_PER_SEC);

	return 0;
}
